#define crtc_pib(arg) ((struct vesafb_crtc_info_block*)(arg))
#define vbe_pib(arg) ((struct vesafb_vbe_info_block*)(arg))
#define vesafb_pmib(arg) ((struct vesafb_mode_info_block*)(arg))

struct vesafb_task {
	enum { 
		VESAFB_TASK_DOVM86, 
		VESAFB_TASK_GETVBE_IB, 
		VESAFB_TASK_GETVBE_MODEINFO,
		VESAFB_TASK_SWITCHMODE,
		VESAFB_TASK_GETEDID,
		VESAFB_TASK_SETPAL
	} type;

	unsigned short		flags;
	struct vm86_regs 	regs;

	unsigned char		done;
	void 			*res;
		
	struct list_head 	node;
};

#define VESAFB_FLAG_FREESTRUCT		0x0001
#define VESAFB_CAP_CAN_SWITCH_DAC	0x01

/* this struct is 512 bytes long */
struct vesafb_vbe_info_block {
	char	vbe_signature[4];
	u16	vbe_version;
	u32	oem_string_ptr;
	u32	capabilities;
	u32 	mode_list_ptr;
	u16 	total_memory;
	u16	oem_software_rev;
	u32	oem_vendor_name_ptr;
	u32 	oem_product_name_ptr;
	u32 	oem_product_rev_ptr;
	u8	reserved[222];
	char	oem_data[256];
} __attribute__ ((packed));

struct vesafb_crtc_info_block {
	u16	horiz_total;
	u16	horiz_start;
	u16	horiz_end;
	u16	vert_total;
	u16	vert_start;
	u16	vert_end;
	u8	flags;
	u32	pixel_clock;
	u16	refresh_rate;
	u8	reserved[40];
} __attribute__ ((packed));

/* this struct is 256 bytes long */
struct vesafb_mode_info_block {

	/* for all VBE revisions */
	u16	mode_attr;
	u8	winA_attr;
	u8	winB_attr;
	u16	win_granularity;
	u16	win_size;
	u16	winA_seg;
	u16	winB_seg;
	u32	win_func_ptr;
	u16	bytes_per_scan_line;
	
	/* for VBE 1.2+ */
	u16	x_res;
	u16	y_res;
	u8	x_char_size;
	u8	y_char_size;
	u8	planes;
	u8	bits_per_pixel;
	u8	banks;
	u8	memory_model;
	u8	bank_size;
	u8	image_pages;
	u8	reserved1;
	
	/* direct color fields for direct/6 and YUV/7 memory models */
	u8	red_len;
	u8	red_off;		/* offsets are bit positions of lsb in the mask */
	u8	green_len;
	u8	green_off;
	u8	blue_len;
	u8	blue_off;
	u8	rsvd_len;
	u8	rsvd_off;
	u8	direct_color_info;	/* direct color mode attributes */

	/* for VBE 2.0+ */
	u32	phys_base_ptr;
	u8	reserved2[6];
	
	/* for VBE 3.0+ */
	u16	lin_bytes_per_scan_line;
	u8	bnk_image_pages;
	u8	lin_image_pages;
	u8	lin_red_len;
	u8	lin_red_off;
	u8	lin_green_len;
	u8	lin_green_off;
	u8	lin_blue_len;
	u8	lin_blue_off;
	u8	lin_rsvd_len;
	u8	lin_rsvd_off;
	u32	max_pixel_clock;
	u16	mode_id;
} __attribute__ ((packed));

struct vesafb_par {
	u16 				vbe_mode;
	struct vesafb_crtc_info_block 	crtc;	
};

struct vesafb_pal_entry {
	u_char blue, green, red, pad; 
} __attribute__ ((packed));

